<template>
  <div class="picker-wrap">
    <div
      class="picker-wrap-txt"
      :class="{ placeholder: !String(pickerValShow) }"
      @click="show = true"
    >
      <span>{{ pickerValShow || placeholder }}</span>
      <svg-icon icon-class="triangle-right" slot="button" />
    </div>
    <cr-popup v-model="show" position="bottom" get-container="body">
      <cr-date-picker
        ref="datepicker"
        @confirm="onConfirm"
        @cancel="onCancel"
        :init-value="initVal"
      />
    </cr-popup>
  </div>
</template>

<script>
import popupPickerMixin from "../mixins/popupPicker.mixin.js";
import { parseTime } from "@/service/utils";

export default {
  name: "PopupDatePicker",
  mixins: [popupPickerMixin],
  data() {
    return {
      refName: "datepicker",
      initVal: parseTime("", "{y}-{m}-{d}")
    };
  },
  watch: {
    value(val) {
      if (val) {
        this.initVal = val;
        this.handleResult(val);
      }
    }
  },

  methods: {
    handleResult(res) {
      this.pickerValShow = res;
      this.pickerVal = res;
    },
    setDefaultVal() {
      setTimeout(() => {
        const $datepicker = this.$refs.datepicker;
        const $picker = $datepicker.$refs.picker;
        const columns = $datepicker.columns;
        $datepicker.setInitValue();
        $picker.setColumnIndex(0, columns[0].selectedIndex);
        $picker.setColumnIndex(1, columns[1].selectedIndex);
        $picker.setColumnIndex(2, columns[2].selectedIndex);
      });
    }
  }
};
</script>
<style lang="less">
.picker-wrap {
  width: 100%;
  &-txt {
    height: 24px;
    color: #333;
    font-size: 14px;
    display: flex;
    justify-content: space-between;
    align-items: center;
  }
  .svg-icon {
    height: 16px;
    width: 16px;
  }
  .placeholder {
    color: #ccc;
  }
}
</style>
